// let the bg script know the site has been visited
// it'll decide if a site must be blocked or not
chrome.runtime.sendMessage({
  action: "siteVisited",
  payload: { currentSite: window.location.hostname },
});

chrome.runtime.sendMessage({
  action: "autoBlockCheck",
  payload: { currentSite: window.location.hostname },
});

function createAutoBlockTimerUI() {
  const div = document.createElement("div");
  div.classList.add("timerContainer");
  div.style.background = "#fff";

  const innerDiv = document.createElement("div");
  innerDiv.classList.add("innenrContainer");

  const progressbar = document.createElement("div");
  progressbar.classList.add("progress_bar_inner");
  progressbar.classList.add("otto_progress_bar_inner");

  innerDiv.appendChild(progressbar);
  div.appendChild(innerDiv);
  document.body.appendChild(div);
}

function updateAutoblockTimer() {
  const pb = document.querySelector(".otto_progress_bar_inner");
  console.log(response.percentage);
  const per = 100 - response.percentage;
  pb.style.width = `${per}%`;

  if (per < 35) {
    pb.style.background =
      "linear-gradient(86.55deg, #FF8787 -0.58%, #FF4545 95.38%)";
  }
}

chrome.runtime.onMessage.addListener(function (response, sender) {
  if (response.action === "injectTimer") {
    // createAutoBlockTimerUI();
  }

  if (response.action === "updateAutoblockTimer") {
    // updateAutoblockTimer()
  }

  // show blocked page
  if (response.action === "blockSite") {
    const blockPageUrl = chrome.extension.getURL("/blockedUI.html");

    chrome.runtime.sendMessage({
      action: "redirectToBlockPage",
      payload: { redirect: blockPageUrl },
    });

    // record distraction with health
    chrome.runtime.sendMessage({
      action: "depleteHealth",
      payload: { health: 10 },
    });

    // every time site is blocked an event is triggered 'userDistracted'
    // in the insights.dailyDistractionList object a key value pair is added
    // current date will be the key and the distraction count will be the value
    // if current date already exists, then it updates the count
    // if it doesn't exist, it creates one.

    // record distraction with health
    chrome.runtime.sendMessage({
      action: "userDistracted",
      payload: {},
    });
  }
});
