function gotoSection(name) {
  var i;
  var x = document.getElementsByClassName("tab_section");
  for (i = 0; i < x.length; i++) {
    x[i].style.display = "none";
  }
  // settings_section
  document.getElementById(name).style.display = "block";
  const settingsLabel = document.querySelector("#tabSettings");
  const blockListLabel = document.querySelector("#tabBlockList");
  const sharingLabel = document.querySelector("#tabSharing");
  const autoblockLabel = document.querySelector("#tabAutoblock");

  if (name === "blocklist_section") {
    settingsLabel.classList.remove("tabLabelActive");
    sharingLabel.classList.remove("tabLabelActive");
    autoblockLabel.classList.remove("tabLabelActive");
    blockListLabel.classList.add("tabLabelActive");
  } else if (name === "settings_section") {
    settingsLabel.classList.add("tabLabelActive");
    blockListLabel.classList.remove("tabLabelActive");
    autoblockLabel.classList.remove("tabLabelActive");
    sharingLabel.classList.remove("tabLabelActive");
  } else if (name === "sharing_section") {
    settingsLabel.classList.remove("tabLabelActive");
    blockListLabel.classList.remove("tabLabelActive");
    autoblockLabel.classList.remove("tabLabelActive");
    sharingLabel.classList.add("tabLabelActive");
  } else if (name === "autoblock_section") {
    settingsLabel.classList.remove("tabLabelActive");
    blockListLabel.classList.remove("tabLabelActive");
    sharingLabel.classList.remove("tabLabelActive");
    autoblockLabel.classList.add("tabLabelActive");
  }
}

function gotoInsightSection(name) {
  var i;
  var x = document.getElementsByClassName("tab_insights_section");
  for (i = 0; i < x.length; i++) {
    x[i].style.display = "none";
  }
  // settings_section
  document.getElementById(name).style.display = "block";

  const tabInsights = document.querySelector("#tabInsights");
  const tabAdvancedInsights = document.querySelector("#tabAdvancedInsights");

  if (name === "GeneralInsightsSection") {
    tabAdvancedInsights.classList.remove("tabLabelActive");
    tabInsights.classList.add("tabLabelActive");
  } else {
    tabAdvancedInsights.classList.add("tabLabelActive");
    tabInsights.classList.remove("tabLabelActive");
  }
}

function showAutoblockScreen() {
  const appStartScreen = document.querySelector(".showStartScreen");
  const appTimerScreen = document.querySelector(".showTimerScreen");
  const appSettingScreen = document.querySelector(".showSettingsScreen");
  const appInsightsScreen = document.querySelector(".showInsightsScreen");
  const animationContainer = document.querySelector(".animationContainer");

  gotoSection("autoblock_section");

  hide(appStartScreen);
  hide(appTimerScreen);
  hide(animationContainer);
  hide(appInsightsScreen);
  show(appSettingScreen);
}

function showSettings() {
  const appStartScreen = document.querySelector(".showStartScreen");
  const appTimerScreen = document.querySelector(".showTimerScreen");
  const appSettingScreen = document.querySelector(".showSettingsScreen");
  const appInsightsScreen = document.querySelector(".showInsightsScreen");
  const animationContainer = document.querySelector(".animationContainer");

  hide(appStartScreen);
  hide(appTimerScreen);
  hide(animationContainer);
  hide(appInsightsScreen);
  show(appSettingScreen);
}

function showInsights() {
  const appStartScreen = document.querySelector(".showStartScreen");
  const appTimerScreen = document.querySelector(".showTimerScreen");
  const appSettingScreen = document.querySelector(".showSettingsScreen");
  const appInsightsScreen = document.querySelector(".showInsightsScreen");
  const animationContainer = document.querySelector(".animationContainer");

  gotoInsightSection("advancedInsightsSection");

  hide(appStartScreen);
  hide(appTimerScreen);
  hide(animationContainer);
  show(appInsightsScreen);
  hide(appSettingScreen);
}

const notificationListFree = [
  {
    notificationName: "notification_upgrade_pro",
    content: "Get more features with Otto Pro",
    buttonLabel: "Upgrade to Pro",
    action: "link", // [link, navigate]
    colorClass: "black",
    data: {
      url: "https://gumroad.com/l/ottopro", // [function, url]
    },
  },
  {
    notificationName: "goto_advanceInsights",
    content: "Learn more about your browsing usage",
    buttonLabel: "Check it out",
    action: "navigate", // [link, navigate]
    colorClass: "orange",
    data: {
      function: showInsights, // [function, url]
    },
  },
];

const notificationListPro = [
  {
    notificationName: "goto_advanceInsights",
    content: "Learn more about your browsing usage",
    buttonLabel: "Check it out",
    action: "navigate", // [link, navigate]
    colorClass: "orange",
    data: {
      function: showInsights, // [function, url]
    },
  },
  {
    notificationName: "autoBlock notification",
    content: "Autoblock sites if you waste too much time",
    buttonLabel: "Show autoblock settings",
    action: "navigate", // [link, navigate]
    colorClass: "black",
    data: {
      function: showAutoblockScreen, // [function, url]
    },
  },

  {
    notificationName: "turnon_notification",
    content: "Turn on push notification after sessions",
    buttonLabel: "Turn on",
    action: "navigate", // [link, navigate]
    colorClass: "black",
    data: {
      function: showSettings, // [function, url]
    },
  },
];

document.addEventListener("DOMContentLoaded", () => {
  chrome.runtime.sendMessage(actions.getAllState, function (response) {
    const { isUserPro } = response.payload;

    let notificationList = isUserPro
      ? notificationListPro
      : notificationListFree;

    const currentNotification =
      notificationList[Math.floor(Math.random() * notificationList.length)];

    const notificationContainerList = document.querySelectorAll(
      ".featureAnnoucementWrapper"
    );

    for (let i = 0; i < notificationContainerList.length; i++) {
      let notificationContainer = notificationContainerList[i];
      const description = document.createElement("p");
      const button = document.createElement("a");

      description.classList.add("newFeatureDesp");
      description.textContent = currentNotification.content;

      if (currentNotification.action === "link") {
        button.classList.add(...["FlatButton", currentNotification.colorClass]);
        button.textContent = currentNotification.buttonLabel;
        button.href = currentNotification.data.url;
        button.target = "_blank";
      }

      if (currentNotification.action === "navigate") {
        button.classList.add(...["FlatButton", currentNotification.colorClass]);
        button.textContent = currentNotification.buttonLabel;
        button.onclick = currentNotification.data.function;
      }

      notificationContainer.appendChild(description);
      notificationContainer.appendChild(button);

      button.addEventListener("click", () => {
        trackButton(currentNotification.notificationName);
      });
    }
  });
});
