document.addEventListener("DOMContentLoaded", () => {
  const verifyInput = document.querySelector(".verifyKeyInput");
  const verifyButton = document.querySelector(".verifyKeyButton");

  // button tracking
  const buyProButton = document.querySelector(".buyProButton");
  const seePricingButton = document.querySelector(".seePricing");

  buyProButton.addEventListener("click", () => {
    trackButton("buyProButton_otto_screen");
  });

  seePricingButton.addEventListener("click", () => {
    trackButton("seePricingButton_otto_screen");
  });

  chrome.runtime.sendMessage(actions.getAllState, function (response) {
    const { isUserPro, proLicenseKey } = response.payload;
    if (isUserPro) {
      verifyButton.textContent = "Activated";
      verifyButton.classList.add("proActivated");
      verifyButton.classList.add("disabled");

      verifyButton.disabled = true;

      verifyInput.value = proLicenseKey;
      verifyInput.disabled = true;
      verifyInput.classList.add(["disabled"]);
    }
  });

  verifyButton.addEventListener("click", async () => {
    let key = verifyInput.value;
    let perma = "ottopro";
    let endpoint = "https://api.gumroad.com/v2/licenses/verify";
    let response = await fetch(endpoint, {
      body: `product_permalink=${perma}&license_key=${key}`,
      headers: {
        "Content-Type": "application/x-www-form-urlencoded",
      },
      method: "POST",
    });

    if (key.length === 0) {
      verifyButton.textContent = "Empty, such wow!";
    } else {
      if (response.status === 200) {
        let data = await response.json();
        if (data.success) {
          verifyButton.textContent = "Yay, Activated!";
          verifyButton.disabled = true;
          verifyButton.classList.add("proActivated");

          chrome.runtime.sendMessage({
            action: "activatePro",
            payload: { key: key },
          });

          trackButton("pro_activated");
        } else {
          verifyButton.textContent = "Oops, try again!";
        }
      } else {
        verifyButton.textContent = "Invalid Key, try again!";
      }
    }
  });
});
