class AppState {
  constructor() {
    this.appState = {
      isTimerOn: false,
      isPaused: false,
      currentScreenState: "startScreen",
      timerCount: 25 * 60, // 25 min
      breakCount: 5 * 60, // 5 min
      blockedSites: [
        "twitter.com",
        "instagram.com",
        "facebook.com",
        "youtube.com",
        "twitch.tv",
      ],
      autoBlockedSites: [],
      intervalTimerID: null,
      health: 100,
      isBreakTime: false,
      autoblock: true,
      hardMode: false,
      insightsData: {},
      soundsOn: true,
      currentColor: "blue",
      pushNotificationsEnabled: false,
      disableBlockInBreakMode: false,
      topSitesData: {},
      proLicenseKey: undefined,
      isUserPro: false,
    };
  }

  // need to write a function to rehydrate local storage with new states

  getStates() {
    return this.appState;
  }

  getState(type) {
    if (this.appState.hasOwnProperty(type)) {
      return this.appState[type];
    }
    return null;
  }

  save(state) {
    chrome.storage.local.set({ appData: state });
  }

  setAll(object) {
    this.appState = object !== undefined ? object : this.appState;
  }

  setState(type, value) {
    this.appState[type] = value;
    this.save(this.appState);
  }
}
