function stripurl(url) {
  return url !== undefined
    ? url.replace(/^(?:https?:\/\/)?(?:www\.)?/i, "").split("/")[0]
    : "";
}

chrome.webRequest.onBeforeRequest.addListener(
  function(details) {
    const isTimerOn = state.getState("isTimerOn");
    const autoBlockOn = state.getState("autoblock");

    if (!isTimerOn && autoBlockOn) {
      const autoBlockedSiteList = state.getState("autoBlockedSites");
      const url = details.initiator;
      const strippedUrl = stripurl(url);

      const siteList = [];
      autoBlockedSiteList.map(x => siteList.push(x.siteName));
      const isAutoBlocked =
        siteList.includes(strippedUrl) && autoBlockedSiteList[0].blocked; // check if site is in the list and blocked at the same time

      return { cancel: isAutoBlocked };
    } else {
      console.log("[DEBUG]: Autoblock is off");
    }
  },
  {
    urls: generateAutoBlockURLVariations(state.getState("autoBlockedSites"))
  },
  ["blocking"]
);

function generateAutoBlockURLVariations(urls) {
  let autoblockedVariations = [];
  urls.map(urlObj => {
    if (urlObj.blocked) {
      const strippedBase = urlObj.siteName
        .replace(/^(?:https?:\/\/)?(?:www\.)?/i, "")
        .split("/")[0];

      autoblockedVariations.push([
        `*://*.${strippedBase}/*`,
        `*://${strippedBase}/*`,
        `*://www.${strippedBase}/*`
      ]);
    }
  });
  return [].concat.apply([], autoblockedVariations);
}
